diff a/src/hotspot/share/utilities/macros.hpp b/src/hotspot/share/utilities/macros.hpp
--- a/src/hotspot/share/utilities/macros.hpp
+++ b/src/hotspot/share/utilities/macros.hpp
@@ -265,10 +265,29 @@
 #else
 #define JFR_ONLY(code)
 #define NOT_JFR_RETURN_(code) { return code; }
 #endif
 
+#ifndef INCLUDE_TSAN
+#define INCLUDE_TSAN 1
+#endif
+
+#if INCLUDE_TSAN
+#define TSAN_ONLY(code) code
+#define TSAN_RUNTIME_ONLY(code) \
+    do { \
+      if (ThreadSanitizer) { \
+        code; \
+      } \
+    } while (0)
+#define NOT_TSAN(code)
+#else
+#define TSAN_ONLY(code)
+#define TSAN_RUNTIME_ONLY(code)
+#define NOT_TSAN(code) code
+#endif
+
 #ifndef INCLUDE_JVMCI
 #define INCLUDE_JVMCI 1
 #endif
 
 #ifndef INCLUDE_AOT
